import { __decorate, __metadata, __param } from 'tslib';
import { ɵɵdefineInjectable, Injectable, ElementRef, Optional, Inject, Input, Component, ViewEncapsulation, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { DOCUMENT } from '@angular/common';

var FontAwesomeIconsRegistry = /** @class */ (function () {
    function FontAwesomeIconsRegistry() {
        this.registry = new Map();
    }
    FontAwesomeIconsRegistry.prototype.registerIcons = function (icons) {
        var _this = this;
        icons.forEach(function (icon) { return _this.registry.set(icon.name, icon.data); });
    };
    FontAwesomeIconsRegistry.prototype.getIcon = function (iconName) {
        if (!this.registry.has(iconName)) {
            console.warn("We could not find the dinosaur Icon with the name " + iconName + ", did you add it to the Icon registry?");
        }
        return this.registry.get(iconName);
    };
    FontAwesomeIconsRegistry.ɵprov = ɵɵdefineInjectable({ factory: function FontAwesomeIconsRegistry_Factory() { return new FontAwesomeIconsRegistry(); }, token: FontAwesomeIconsRegistry, providedIn: "root" });
    FontAwesomeIconsRegistry = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], FontAwesomeIconsRegistry);
    return FontAwesomeIconsRegistry;
}());

var FontAwesomeIconComponent = /** @class */ (function () {
    function FontAwesomeIconComponent(element, iconsRegistry, document) {
        this.element = element;
        this.iconsRegistry = iconsRegistry;
        this.document = document;
    }
    Object.defineProperty(FontAwesomeIconComponent.prototype, "name", {
        set: function (iconName) {
            if (this.svgIcon) {
                this.element.nativeElement.removeChild(this.svgIcon);
            }
            var svgData = this.iconsRegistry.getIcon(iconName);
            if (svgData) {
                this.svgIcon = this.svgElementFromString(svgData);
                this.element.nativeElement.appendChild(this.svgIcon);
            }
        },
        enumerable: true,
        configurable: true
    });
    FontAwesomeIconComponent.prototype.svgElementFromString = function (svgContent) {
        var div = this.document.createElement('DIV');
        if (div instanceof HTMLElement) {
            div.innerHTML = svgContent;
            return div.querySelector('svg') || this.document.createElementNS('http://www.w3.org/2000/svg', 'path');
        }
    };
    FontAwesomeIconComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FontAwesomeIconsRegistry },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DOCUMENT,] }] }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], FontAwesomeIconComponent.prototype, "name", null);
    FontAwesomeIconComponent = __decorate([
        Component({
            selector: 'font-awesome-icon',
            template: "<ng-content></ng-content>",
            encapsulation: ViewEncapsulation.None,
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        __param(2, Optional()), __param(2, Inject(DOCUMENT)),
        __metadata("design:paramtypes", [ElementRef,
            FontAwesomeIconsRegistry, Object])
    ], FontAwesomeIconComponent);
    return FontAwesomeIconComponent;
}());

var FontAwesomeIconsModule = /** @class */ (function () {
    function FontAwesomeIconsModule() {
    }
    FontAwesomeIconsModule_1 = FontAwesomeIconsModule;
    FontAwesomeIconsModule.forRoot = function () {
        return {
            ngModule: FontAwesomeIconsModule_1,
            providers: [
                FontAwesomeIconsRegistry,
            ],
        };
    };
    var FontAwesomeIconsModule_1;
    FontAwesomeIconsModule = FontAwesomeIconsModule_1 = __decorate([
        NgModule({
            declarations: [FontAwesomeIconComponent],
            imports: [],
            exports: [FontAwesomeIconComponent]
        })
    ], FontAwesomeIconsModule);
    return FontAwesomeIconsModule;
}());

/*
 * Public API Surface of the icons lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { FontAwesomeIconComponent, FontAwesomeIconsModule, FontAwesomeIconsRegistry };
//# sourceMappingURL=triangular-font-awesome-icons.js.map
